/* midori-tab.c generated by valac 0.20.1, the Vala compiler
 * generated from midori-tab.vala, do not modify */

/*
 Copyright (C) 2007-2012 Christian Dywan <christian@twotoasts.de>
 Copyright (C) 2009 Jean-François Guchens <zcx000@gmail.com>
 Copyright (C) 2011 Peter Hatina <phatina@redhat.com>

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 See the file COPYING for the full license text.
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <webkit/webkit.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <pango/pango.h>


#define MIDORI_TYPE_NEW_VIEW (midori_new_view_get_type ())

#define MIDORI_TYPE_SECURITY (midori_security_get_type ())

#define MIDORI_TYPE_LOAD_STATUS (midori_load_status_get_type ())

#define MIDORI_TYPE_TAB (midori_tab_get_type ())
#define MIDORI_TAB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MIDORI_TYPE_TAB, MidoriTab))
#define MIDORI_TAB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MIDORI_TYPE_TAB, MidoriTabClass))
#define MIDORI_IS_TAB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MIDORI_TYPE_TAB))
#define MIDORI_IS_TAB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MIDORI_TYPE_TAB))
#define MIDORI_TAB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MIDORI_TYPE_TAB, MidoriTabClass))

typedef struct _MidoriTab MidoriTab;
typedef struct _MidoriTabClass MidoriTabClass;
typedef struct _MidoriTabPrivate MidoriTabPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	MIDORI_NEW_VIEW_TAB,
	MIDORI_NEW_VIEW_BACKGROUND,
	MIDORI_NEW_VIEW_WINDOW
} MidoriNewView;

typedef enum  {
	MIDORI_SECURITY_NONE,
	MIDORI_SECURITY_UNKNOWN,
	MIDORI_SECURITY_TRUSTED
} MidoriSecurity;

typedef enum  {
	MIDORI_LOAD_FINISHED,
	MIDORI_LOAD_COMMITTED,
	MIDORI_LOAD_PROVISIONAL
} MidoriLoadStatus;

struct _MidoriTab {
	GtkVBox parent_instance;
	MidoriTabPrivate * priv;
};

struct _MidoriTabClass {
	GtkVBoxClass parent_class;
};

struct _MidoriTabPrivate {
	WebKitWebView* _web_view;
	gchar* current_uri;
	gboolean _special;
	gchar* _mime_type;
	MidoriSecurity _security;
	MidoriLoadStatus _load_status;
	gchar* _statusbar_text;
	GdkColor* _fg_color;
	GdkColor* _bg_color;
	gdouble current_progress;
};


static gpointer midori_tab_parent_class = NULL;

GType midori_new_view_get_type (void) G_GNUC_CONST;
GType midori_security_get_type (void) G_GNUC_CONST;
GType midori_load_status_get_type (void) G_GNUC_CONST;
GType midori_tab_get_type (void) G_GNUC_CONST;
#define MIDORI_TAB_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), MIDORI_TYPE_TAB, MidoriTabPrivate))
enum  {
	MIDORI_TAB_DUMMY_PROPERTY,
	MIDORI_TAB_WEB_VIEW,
	MIDORI_TAB_URI,
	MIDORI_TAB_SPECIAL,
	MIDORI_TAB_MIME_TYPE,
	MIDORI_TAB_SECURITY,
	MIDORI_TAB_LOAD_STATUS,
	MIDORI_TAB_STATUSBAR_TEXT,
	MIDORI_TAB_PROGRESS,
	MIDORI_TAB_VIEW_SOURCE
};
gboolean midori_tab_is_blank (MidoriTab* self);
gboolean midori_uri_is_blank (const gchar* uri);
const gchar* midori_tab_get_uri (MidoriTab* self);
void midori_tab_inject_stylesheet (MidoriTab* self, const gchar* stylesheet);
WebKitWebView* midori_tab_get_web_view (MidoriTab* self);
gboolean midori_tab_can_view_source (MidoriTab* self);
gboolean midori_tab_get_special (MidoriTab* self);
gboolean midori_tab_get_view_source (MidoriTab* self);
const gchar* midori_tab_get_mime_type (MidoriTab* self);
gchar* midori_tab_get_display_title (const gchar* title, const gchar* uri);
gchar* midori_uri_strip_prefix_for_display (const gchar* uri);
PangoEllipsizeMode midori_tab_get_display_ellipsize (const gchar* title, const gchar* uri);
gboolean midori_tab_can_save (MidoriTab* self);
void midori_tab_stop_loading (MidoriTab* self);
gboolean midori_tab_can_go_forward (MidoriTab* self);
void midori_tab_go_forward (MidoriTab* self);
void midori_tab_unmark_text_matches (MidoriTab* self);
gboolean midori_tab_find (MidoriTab* self, const gchar* text, gboolean case_sensitive, gboolean forward);
MidoriTab* midori_tab_new (void);
MidoriTab* midori_tab_construct (GType object_type);
static void midori_tab_set_web_view (MidoriTab* self, WebKitWebView* value);
void midori_tab_set_uri (MidoriTab* self, const gchar* value);
gchar* midori_uri_format_for_display (const gchar* uri);
void midori_tab_set_special (MidoriTab* self, gboolean value);
void midori_tab_set_mime_type (MidoriTab* self, const gchar* value);
MidoriSecurity midori_tab_get_security (MidoriTab* self);
void midori_tab_set_security (MidoriTab* self, MidoriSecurity value);
MidoriLoadStatus midori_tab_get_load_status (MidoriTab* self);
void midori_tab_set_load_status (MidoriTab* self, MidoriLoadStatus value);
const gchar* midori_tab_get_statusbar_text (MidoriTab* self);
void midori_tab_set_statusbar_text (MidoriTab* self, const gchar* value);
GdkColor* midori_tab_get_fg_color (MidoriTab* self);
void midori_tab_set_fg_color (MidoriTab* self, GdkColor* value);
static GdkColor* _gdk_color_dup (GdkColor* self);
GdkColor* midori_tab_get_bg_color (MidoriTab* self);
void midori_tab_set_bg_color (MidoriTab* self, GdkColor* value);
gdouble midori_tab_get_progress (MidoriTab* self);
void midori_tab_set_progress (MidoriTab* self, gdouble value);
void midori_tab_set_view_source (MidoriTab* self, gboolean value);
static void g_cclosure_user_marshal_VOID__STRING_INT_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__BOOLEAN_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static GObject * midori_tab_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void midori_tab_finalize (GObject* obj);
static void _vala_midori_tab_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_midori_tab_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GType midori_new_view_get_type (void) {
	static volatile gsize midori_new_view_type_id__volatile = 0;
	if (g_once_init_enter (&midori_new_view_type_id__volatile)) {
		static const GEnumValue values[] = {{MIDORI_NEW_VIEW_TAB, "MIDORI_NEW_VIEW_TAB", "tab"}, {MIDORI_NEW_VIEW_BACKGROUND, "MIDORI_NEW_VIEW_BACKGROUND", "background"}, {MIDORI_NEW_VIEW_WINDOW, "MIDORI_NEW_VIEW_WINDOW", "window"}, {0, NULL, NULL}};
		GType midori_new_view_type_id;
		midori_new_view_type_id = g_enum_register_static ("MidoriNewView", values);
		g_once_init_leave (&midori_new_view_type_id__volatile, midori_new_view_type_id);
	}
	return midori_new_view_type_id__volatile;
}


GType midori_security_get_type (void) {
	static volatile gsize midori_security_type_id__volatile = 0;
	if (g_once_init_enter (&midori_security_type_id__volatile)) {
		static const GEnumValue values[] = {{MIDORI_SECURITY_NONE, "MIDORI_SECURITY_NONE", "none"}, {MIDORI_SECURITY_UNKNOWN, "MIDORI_SECURITY_UNKNOWN", "unknown"}, {MIDORI_SECURITY_TRUSTED, "MIDORI_SECURITY_TRUSTED", "trusted"}, {0, NULL, NULL}};
		GType midori_security_type_id;
		midori_security_type_id = g_enum_register_static ("MidoriSecurity", values);
		g_once_init_leave (&midori_security_type_id__volatile, midori_security_type_id);
	}
	return midori_security_type_id__volatile;
}


GType midori_load_status_get_type (void) {
	static volatile gsize midori_load_status_type_id__volatile = 0;
	if (g_once_init_enter (&midori_load_status_type_id__volatile)) {
		static const GEnumValue values[] = {{MIDORI_LOAD_FINISHED, "MIDORI_LOAD_FINISHED", "finished"}, {MIDORI_LOAD_COMMITTED, "MIDORI_LOAD_COMMITTED", "committed"}, {MIDORI_LOAD_PROVISIONAL, "MIDORI_LOAD_PROVISIONAL", "provisional"}, {0, NULL, NULL}};
		GType midori_load_status_type_id;
		midori_load_status_type_id = g_enum_register_static ("MidoriLoadStatus", values);
		g_once_init_leave (&midori_load_status_type_id__volatile, midori_load_status_type_id);
	}
	return midori_load_status_type_id__volatile;
}


gboolean midori_tab_is_blank (MidoriTab* self) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 92 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 93 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = midori_tab_get_uri (self);
#line 93 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = _tmp0_;
#line 93 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp2_ = midori_uri_is_blank (_tmp1_);
#line 93 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = _tmp2_;
#line 93 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 213 "midori-tab.c"
}


void midori_tab_inject_stylesheet (MidoriTab* self, const gchar* stylesheet) {
	WebKitWebView* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
#line 110 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (self != NULL);
#line 110 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (stylesheet != NULL);
#line 125 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->_web_view;
#line 125 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = stylesheet;
#line 125 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp2_ = g_strdup_printf ("\n" \
"                (function () {\n" \
"                var style = document.createElement ('style');\n" \
"                style.setAttribute ('type', 'text/css');\n" \
"                style.appendChild (document.createTextNode ('%s'));\n" \
"                var head = document.getElementsByTagName ('head')[0];\n" \
"                if (head) head.appendChild (style);\n" \
"                else document.documentElement.insertBefore\n" \
"                (style, document.documentElement.firstChild);\n" \
"                }) ();\n" \
"                ", _tmp1_);
#line 125 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp3_ = _tmp2_;
#line 125 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	webkit_web_view_execute_script (_tmp0_, _tmp3_);
#line 125 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_g_free0 (_tmp3_);
#line 238 "midori-tab.c"
}


gboolean midori_tab_can_view_source (MidoriTab* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_;
	gboolean _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* content_type;
	gchar* _tmp10_ = NULL;
	gchar* text_type;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gboolean _tmp13_ = FALSE;
#line 160 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 161 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp2_ = midori_tab_is_blank (self);
#line 161 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (_tmp2_) {
#line 161 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp1_ = TRUE;
#line 265 "midori-tab.c"
	} else {
		gboolean _tmp3_;
#line 161 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp3_ = self->priv->_special;
#line 161 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp1_ = _tmp3_;
#line 272 "midori-tab.c"
	}
#line 161 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp4_ = _tmp1_;
#line 161 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (_tmp4_) {
#line 161 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp0_ = TRUE;
#line 280 "midori-tab.c"
	} else {
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 161 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp5_ = midori_tab_get_view_source (self);
#line 161 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp6_ = _tmp5_;
#line 161 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp0_ = _tmp6_;
#line 290 "midori-tab.c"
	}
#line 161 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp7_ = _tmp0_;
#line 161 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (_tmp7_) {
#line 162 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		result = FALSE;
#line 162 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		return result;
#line 300 "midori-tab.c"
	}
#line 163 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp8_ = self->priv->_mime_type;
#line 163 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp9_ = g_content_type_from_mime_type (_tmp8_);
#line 163 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	content_type = _tmp9_;
#line 168 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp10_ = g_content_type_from_mime_type ("text/plain");
#line 168 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	text_type = _tmp10_;
#line 170 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp11_ = content_type;
#line 170 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp12_ = text_type;
#line 170 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp13_ = g_content_type_is_a (_tmp11_, _tmp12_);
#line 170 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = _tmp13_;
#line 170 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_g_free0 (text_type);
#line 170 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_g_free0 (content_type);
#line 170 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 326 "midori-tab.c"
}


gchar* midori_tab_get_display_title (const gchar* title, const gchar* uri) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gboolean _tmp8_;
	gboolean _tmp14_ = FALSE;
	const gchar* _tmp15_;
	gboolean _tmp21_;
	const gchar* _tmp24_;
	gboolean _tmp25_ = FALSE;
	const gchar* _tmp28_;
	gchar* _tmp29_;
#line 173 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 175 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = title;
#line 175 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (_tmp1_ == NULL) {
#line 348 "midori-tab.c"
		gboolean _tmp2_ = FALSE;
		const gchar* _tmp3_;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp7_;
#line 175 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp3_ = uri;
#line 175 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp4_ = g_str_has_suffix (_tmp3_, ".diff");
#line 175 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		if (_tmp4_) {
#line 175 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
			_tmp2_ = TRUE;
#line 361 "midori-tab.c"
		} else {
			const gchar* _tmp5_;
			gboolean _tmp6_ = FALSE;
#line 175 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
			_tmp5_ = uri;
#line 175 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
			_tmp6_ = g_str_has_suffix (_tmp5_, ".patch");
#line 175 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
			_tmp2_ = _tmp6_;
#line 371 "midori-tab.c"
		}
#line 175 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp7_ = _tmp2_;
#line 175 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp0_ = _tmp7_;
#line 377 "midori-tab.c"
	} else {
#line 175 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp0_ = FALSE;
#line 381 "midori-tab.c"
	}
#line 175 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp8_ = _tmp0_;
#line 175 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (_tmp8_) {
#line 387 "midori-tab.c"
		const gchar* _tmp9_;
		GFile* _tmp10_ = NULL;
		GFile* _tmp11_;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_;
#line 176 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp9_ = uri;
#line 176 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp10_ = g_file_new_for_uri (_tmp9_);
#line 176 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp11_ = _tmp10_;
#line 176 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp12_ = g_file_get_basename (_tmp11_);
#line 176 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp13_ = _tmp12_;
#line 176 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_g_object_unref0 (_tmp11_);
#line 176 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		result = _tmp13_;
#line 176 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		return result;
#line 409 "midori-tab.c"
	}
#line 179 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp15_ = title;
#line 179 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (_tmp15_ == NULL) {
#line 179 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp14_ = TRUE;
#line 417 "midori-tab.c"
	} else {
		gboolean _tmp16_ = FALSE;
		const gchar* _tmp17_;
		gboolean _tmp20_;
#line 179 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp17_ = title;
#line 179 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		if (g_strcmp0 (_tmp17_, "OMG!") == 0) {
#line 426 "midori-tab.c"
			const gchar* _tmp18_;
			gboolean _tmp19_ = FALSE;
#line 179 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
			_tmp18_ = uri;
#line 179 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
			_tmp19_ = g_str_has_prefix (_tmp18_, "file://");
#line 179 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
			_tmp16_ = _tmp19_;
#line 435 "midori-tab.c"
		} else {
#line 179 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
			_tmp16_ = FALSE;
#line 439 "midori-tab.c"
		}
#line 179 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp20_ = _tmp16_;
#line 179 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp14_ = _tmp20_;
#line 445 "midori-tab.c"
	}
#line 179 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp21_ = _tmp14_;
#line 179 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (_tmp21_) {
#line 451 "midori-tab.c"
		const gchar* _tmp22_;
		gchar* _tmp23_ = NULL;
#line 180 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp22_ = uri;
#line 180 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp23_ = midori_uri_strip_prefix_for_display (_tmp22_);
#line 180 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		result = _tmp23_;
#line 180 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		return result;
#line 462 "midori-tab.c"
	}
#line 189 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp24_ = title;
#line 189 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp25_ = g_str_has_prefix (_tmp24_, "‪");
#line 189 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (!_tmp25_) {
#line 470 "midori-tab.c"
		const gchar* _tmp26_;
		gchar* _tmp27_;
#line 190 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp26_ = title;
#line 190 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp27_ = g_strconcat ("‪", _tmp26_, NULL);
#line 190 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		result = _tmp27_;
#line 190 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		return result;
#line 481 "midori-tab.c"
	}
#line 192 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp28_ = title;
#line 192 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp29_ = g_strdup (_tmp28_);
#line 192 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = _tmp29_;
#line 192 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 491 "midori-tab.c"
}


PangoEllipsizeMode midori_tab_get_display_ellipsize (const gchar* title, const gchar* uri) {
	PangoEllipsizeMode result = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp7_;
	const gchar* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_ = NULL;
	gchar** parts;
	gint parts_length1;
	gint _parts_size_;
	gboolean _tmp11_ = FALSE;
	gchar** _tmp12_;
	gint _tmp12__length1;
	const gchar* _tmp13_;
	gboolean _tmp21_;
#line 195 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (title != NULL, 0);
#line 195 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (uri != NULL, 0);
#line 196 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = title;
#line 196 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = uri;
#line 196 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
#line 197 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		result = PANGO_ELLIPSIZE_START;
#line 197 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		return result;
#line 528 "midori-tab.c"
	}
#line 199 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp3_ = title;
#line 199 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp4_ = g_str_has_suffix (_tmp3_, ".diff");
#line 199 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (_tmp4_) {
#line 199 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp2_ = TRUE;
#line 538 "midori-tab.c"
	} else {
		const gchar* _tmp5_;
		gboolean _tmp6_ = FALSE;
#line 199 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp5_ = title;
#line 199 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp6_ = g_str_has_suffix (_tmp5_, ".patch");
#line 199 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp2_ = _tmp6_;
#line 548 "midori-tab.c"
	}
#line 199 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp7_ = _tmp2_;
#line 199 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (_tmp7_) {
#line 200 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		result = PANGO_ELLIPSIZE_START;
#line 200 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		return result;
#line 558 "midori-tab.c"
	}
#line 202 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp8_ = title;
#line 202 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, " ", 0);
#line 202 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	parts = _tmp10_;
#line 202 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	parts_length1 = _vala_array_length (_tmp9_);
#line 202 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_parts_size_ = parts_length1;
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp12_ = parts;
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp12__length1 = parts_length1;
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp13_ = _tmp12_[0];
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (_tmp13_ != NULL) {
#line 578 "midori-tab.c"
		const gchar* _tmp14_;
		gchar** _tmp15_;
		gint _tmp15__length1;
		gchar** _tmp16_;
		gint _tmp16__length1;
		const gchar* _tmp17_;
		gchar* _tmp18_ = NULL;
		gchar* _tmp19_;
		gboolean _tmp20_ = FALSE;
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp14_ = uri;
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp15_ = parts;
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp15__length1 = parts_length1;
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp16_ = parts;
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp16__length1 = parts_length1;
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp17_ = _tmp15_[_tmp16__length1 - 1];
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp18_ = g_utf8_strdown (_tmp17_, (gssize) (-1));
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp19_ = _tmp18_;
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp20_ = g_str_has_suffix (_tmp14_, _tmp19_);
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp11_ = _tmp20_;
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_g_free0 (_tmp19_);
#line 610 "midori-tab.c"
	} else {
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp11_ = FALSE;
#line 614 "midori-tab.c"
	}
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp21_ = _tmp11_;
#line 203 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (_tmp21_) {
#line 204 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		result = PANGO_ELLIPSIZE_START;
#line 204 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 204 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		return result;
#line 626 "midori-tab.c"
	}
#line 206 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = PANGO_ELLIPSIZE_END;
#line 206 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 206 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 634 "midori-tab.c"
}


gboolean midori_tab_can_save (MidoriTab* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	WebKitWebView* _tmp6_;
	WebKitWebFrame* _tmp7_ = NULL;
	WebKitWebDataSource* _tmp8_ = NULL;
	GString* _tmp9_ = NULL;
#line 210 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 211 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = midori_tab_is_blank (self);
#line 211 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (_tmp1_) {
#line 211 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp0_ = TRUE;
#line 657 "midori-tab.c"
	} else {
		gboolean _tmp2_;
#line 211 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp2_ = self->priv->_special;
#line 211 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp0_ = _tmp2_;
#line 664 "midori-tab.c"
	}
#line 211 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp3_ = _tmp0_;
#line 211 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (_tmp3_) {
#line 212 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		result = FALSE;
#line 212 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		return result;
#line 674 "midori-tab.c"
	}
#line 213 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp4_ = midori_tab_get_view_source (self);
#line 213 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp5_ = _tmp4_;
#line 213 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (_tmp5_) {
#line 214 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		result = FALSE;
#line 214 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		return result;
#line 686 "midori-tab.c"
	}
#line 216 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp6_ = self->priv->_web_view;
#line 216 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp7_ = webkit_web_view_get_main_frame (_tmp6_);
#line 216 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp8_ = webkit_web_frame_get_data_source (_tmp7_);
#line 216 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp9_ = webkit_web_data_source_get_data (_tmp8_);
#line 216 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (_tmp9_ == NULL) {
#line 217 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		result = FALSE;
#line 217 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		return result;
#line 702 "midori-tab.c"
	}
#line 219 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = TRUE;
#line 219 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 708 "midori-tab.c"
}


void midori_tab_stop_loading (MidoriTab* self) {
	WebKitWebView* _tmp0_;
#line 222 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (self != NULL);
#line 223 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->_web_view;
#line 223 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	webkit_web_view_stop_loading (_tmp0_);
#line 720 "midori-tab.c"
}


gboolean midori_tab_can_go_forward (MidoriTab* self) {
	gboolean result = FALSE;
	WebKitWebView* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 226 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 227 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->_web_view;
#line 227 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = webkit_web_view_can_go_forward (_tmp0_);
#line 227 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = _tmp1_;
#line 227 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 738 "midori-tab.c"
}


void midori_tab_go_forward (MidoriTab* self) {
	WebKitWebView* _tmp0_;
#line 230 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (self != NULL);
#line 234 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->_web_view;
#line 234 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	webkit_web_view_go_forward (_tmp0_);
#line 750 "midori-tab.c"
}


void midori_tab_unmark_text_matches (MidoriTab* self) {
	WebKitWebView* _tmp0_;
#line 237 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (self != NULL);
#line 239 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->_web_view;
#line 239 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	webkit_web_view_unmark_text_matches (_tmp0_);
#line 762 "midori-tab.c"
}


gboolean midori_tab_find (MidoriTab* self, const gchar* text, gboolean case_sensitive, gboolean forward) {
	gboolean result = FALSE;
	gboolean found;
	WebKitWebView* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	WebKitWebView* _tmp5_;
	const gchar* _tmp6_;
	gboolean _tmp7_;
	WebKitWebView* _tmp8_;
#line 243 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 243 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 255 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	found = FALSE;
#line 256 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->_web_view;
#line 256 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = text;
#line 256 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp2_ = case_sensitive;
#line 256 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp3_ = forward;
#line 256 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp4_ = webkit_web_view_search_text (_tmp0_, _tmp1_, _tmp2_, _tmp3_, TRUE);
#line 256 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	found = _tmp4_;
#line 257 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp5_ = self->priv->_web_view;
#line 257 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp6_ = text;
#line 257 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp7_ = case_sensitive;
#line 257 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	webkit_web_view_mark_text_matches (_tmp5_, _tmp6_, _tmp7_, (guint) 0);
#line 258 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp8_ = self->priv->_web_view;
#line 258 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	webkit_web_view_set_highlight_text_matches (_tmp8_, TRUE);
#line 259 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = found;
#line 259 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 812 "midori-tab.c"
}


MidoriTab* midori_tab_construct (GType object_type) {
	MidoriTab * self = NULL;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self = (MidoriTab*) g_object_new (object_type, NULL);
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return self;
#line 822 "midori-tab.c"
}


MidoriTab* midori_tab_new (void) {
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return midori_tab_construct (MIDORI_TYPE_TAB);
#line 829 "midori-tab.c"
}


WebKitWebView* midori_tab_get_web_view (MidoriTab* self) {
	WebKitWebView* result;
	WebKitWebView* _tmp0_;
#line 37 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->_web_view;
#line 37 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = _tmp0_;
#line 37 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 844 "midori-tab.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 37 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return self ? g_object_ref (self) : NULL;
#line 851 "midori-tab.c"
}


static void midori_tab_set_web_view (MidoriTab* self, WebKitWebView* value) {
	WebKitWebView* _tmp0_;
	WebKitWebView* _tmp1_;
#line 37 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (self != NULL);
#line 37 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = value;
#line 37 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 37 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_g_object_unref0 (self->priv->_web_view);
#line 37 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->_web_view = _tmp1_;
#line 37 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_notify ((GObject *) self, "web-view");
#line 870 "midori-tab.c"
}


const gchar* midori_tab_get_uri (MidoriTab* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 44 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->current_uri;
#line 45 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = _tmp0_;
#line 45 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 885 "midori-tab.c"
}


void midori_tab_set_uri (MidoriTab* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
#line 47 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (self != NULL);
#line 48 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = value;
#line 48 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = midori_uri_format_for_display (_tmp0_);
#line 48 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_g_free0 (self->priv->current_uri);
#line 48 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->current_uri = _tmp1_;
#line 47 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_notify ((GObject *) self, "uri");
#line 904 "midori-tab.c"
}


gboolean midori_tab_get_special (MidoriTab* self) {
	gboolean result;
	gboolean _tmp0_;
#line 53 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 53 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->_special;
#line 53 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = _tmp0_;
#line 53 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 919 "midori-tab.c"
}


void midori_tab_set_special (MidoriTab* self, gboolean value) {
	gboolean _tmp0_;
#line 53 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (self != NULL);
#line 53 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = value;
#line 53 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->_special = _tmp0_;
#line 53 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_notify ((GObject *) self, "special");
#line 933 "midori-tab.c"
}


const gchar* midori_tab_get_mime_type (MidoriTab* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 55 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->_mime_type;
#line 55 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = _tmp0_;
#line 55 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 948 "midori-tab.c"
}


void midori_tab_set_mime_type (MidoriTab* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 55 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (self != NULL);
#line 55 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = value;
#line 55 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 55 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_g_free0 (self->priv->_mime_type);
#line 55 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->_mime_type = _tmp1_;
#line 55 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_notify ((GObject *) self, "mime-type");
#line 967 "midori-tab.c"
}


MidoriSecurity midori_tab_get_security (MidoriTab* self) {
	MidoriSecurity result;
	MidoriSecurity _tmp0_;
#line 57 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 57 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->_security;
#line 57 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = _tmp0_;
#line 57 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 982 "midori-tab.c"
}


void midori_tab_set_security (MidoriTab* self, MidoriSecurity value) {
	MidoriSecurity _tmp0_;
#line 57 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (self != NULL);
#line 57 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = value;
#line 57 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->_security = _tmp0_;
#line 57 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_notify ((GObject *) self, "security");
#line 996 "midori-tab.c"
}


MidoriLoadStatus midori_tab_get_load_status (MidoriTab* self) {
	MidoriLoadStatus result;
	MidoriLoadStatus _tmp0_;
#line 58 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 58 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->_load_status;
#line 58 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = _tmp0_;
#line 58 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 1011 "midori-tab.c"
}


void midori_tab_set_load_status (MidoriTab* self, MidoriLoadStatus value) {
	MidoriLoadStatus _tmp0_;
#line 58 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (self != NULL);
#line 58 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = value;
#line 58 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->_load_status = _tmp0_;
#line 58 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_notify ((GObject *) self, "load-status");
#line 1025 "midori-tab.c"
}


const gchar* midori_tab_get_statusbar_text (MidoriTab* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 59 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->_statusbar_text;
#line 59 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = _tmp0_;
#line 59 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 1040 "midori-tab.c"
}


void midori_tab_set_statusbar_text (MidoriTab* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 59 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (self != NULL);
#line 59 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = value;
#line 59 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 59 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_g_free0 (self->priv->_statusbar_text);
#line 59 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->_statusbar_text = _tmp1_;
#line 59 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_notify ((GObject *) self, "statusbar-text");
#line 1059 "midori-tab.c"
}


GdkColor* midori_tab_get_fg_color (MidoriTab* self) {
	GdkColor* result;
	GdkColor* _tmp0_;
#line 61 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->_fg_color;
#line 61 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = _tmp0_;
#line 61 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 1074 "midori-tab.c"
}


static GdkColor* _gdk_color_dup (GdkColor* self) {
	GdkColor* dup;
#line 61 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	dup = g_new0 (GdkColor, 1);
#line 61 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	memcpy (dup, self, sizeof (GdkColor));
#line 61 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return dup;
#line 1086 "midori-tab.c"
}


static gpointer __gdk_color_dup0 (gpointer self) {
#line 61 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return self ? _gdk_color_dup (self) : NULL;
#line 1093 "midori-tab.c"
}


void midori_tab_set_fg_color (MidoriTab* self, GdkColor* value) {
	GdkColor* _tmp0_;
	GdkColor* _tmp1_;
#line 61 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (self != NULL);
#line 61 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = value;
#line 61 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = __gdk_color_dup0 (_tmp0_);
#line 61 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_g_free0 (self->priv->_fg_color);
#line 61 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->_fg_color = _tmp1_;
#line 1110 "midori-tab.c"
}


GdkColor* midori_tab_get_bg_color (MidoriTab* self) {
	GdkColor* result;
	GdkColor* _tmp0_;
#line 62 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->_bg_color;
#line 62 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = _tmp0_;
#line 62 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 1125 "midori-tab.c"
}


void midori_tab_set_bg_color (MidoriTab* self, GdkColor* value) {
	GdkColor* _tmp0_;
	GdkColor* _tmp1_;
#line 62 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (self != NULL);
#line 62 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = value;
#line 62 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = __gdk_color_dup0 (_tmp0_);
#line 62 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_g_free0 (self->priv->_bg_color);
#line 62 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->_bg_color = _tmp1_;
#line 1142 "midori-tab.c"
}


gdouble midori_tab_get_progress (MidoriTab* self) {
	gdouble result;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
	gdouble _tmp3_;
#line 66 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 67 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = self->priv->_special;
#line 67 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (_tmp1_) {
#line 67 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp0_ = 0.0;
#line 1159 "midori-tab.c"
	} else {
		gdouble _tmp2_;
#line 67 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp2_ = self->priv->current_progress;
#line 67 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp0_ = _tmp2_;
#line 1166 "midori-tab.c"
	}
#line 67 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp3_ = _tmp0_;
#line 67 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = _tmp3_;
#line 67 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 1174 "midori-tab.c"
}


void midori_tab_set_progress (MidoriTab* self, gdouble value) {
	MidoriLoadStatus _tmp0_;
#line 69 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (self != NULL);
#line 71 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->_load_status;
#line 71 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (_tmp0_ == MIDORI_LOAD_FINISHED) {
#line 72 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		self->priv->current_progress = 0.0;
#line 1188 "midori-tab.c"
	} else {
		gdouble _tmp1_;
#line 74 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		_tmp1_ = value;
#line 74 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		if (_tmp1_ == 1.0) {
#line 75 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
			self->priv->current_progress = 0.0;
#line 1197 "midori-tab.c"
		} else {
			gdouble _tmp2_;
			gdouble _tmp3_ = 0.0;
#line 78 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
			_tmp2_ = value;
#line 78 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
			_tmp3_ = CLAMP (_tmp2_, 0.1, 1.0);
#line 78 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
			self->priv->current_progress = _tmp3_;
#line 1207 "midori-tab.c"
		}
	}
#line 69 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_notify ((GObject *) self, "progress");
#line 1212 "midori-tab.c"
}


gboolean midori_tab_get_view_source (MidoriTab* self) {
	gboolean result;
	WebKitWebView* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 151 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 152 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->_web_view;
#line 152 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = webkit_web_view_get_view_source_mode (_tmp0_);
#line 152 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	result = _tmp1_;
#line 152 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return result;
#line 1230 "midori-tab.c"
}


void midori_tab_set_view_source (MidoriTab* self, gboolean value) {
	WebKitWebView* _tmp0_;
	gboolean _tmp1_;
#line 154 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (self != NULL);
#line 155 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = self->priv->_web_view;
#line 155 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = value;
#line 155 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	webkit_web_view_set_view_source_mode (_tmp0_, _tmp1_);
#line 154 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_notify ((GObject *) self, "view-source");
#line 1247 "midori-tab.c"
}


static void g_cclosure_user_marshal_VOID__STRING_INT_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_INT_STRING) (gpointer data1, const char* arg_1, gint arg_2, const char* arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_INT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (n_param_values == 4);
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		data1 = closure->data;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		data2 = param_values->data[0].v_pointer;
#line 1266 "midori-tab.c"
	} else {
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		data1 = param_values->data[0].v_pointer;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		data2 = closure->data;
#line 1272 "midori-tab.c"
	}
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	callback = (GMarshalFunc_VOID__STRING_INT_STRING) (marshal_data ? marshal_data : cc->callback);
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_int (param_values + 2), g_value_get_string (param_values + 3), data2);
#line 1278 "midori-tab.c"
}


static void g_cclosure_user_marshal_VOID__BOOLEAN_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__BOOLEAN_STRING) (gpointer data1, gboolean arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOOLEAN_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_return_if_fail (n_param_values == 3);
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		data1 = closure->data;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		data2 = param_values->data[0].v_pointer;
#line 1297 "midori-tab.c"
	} else {
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		data1 = param_values->data[0].v_pointer;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		data2 = closure->data;
#line 1303 "midori-tab.c"
	}
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	callback = (GMarshalFunc_VOID__BOOLEAN_STRING) (marshal_data ? marshal_data : cc->callback);
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	callback (data1, g_value_get_boolean (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 1309 "midori-tab.c"
}


static GObject * midori_tab_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	MidoriTab * self;
	WebKitWebView* _tmp0_;
	WebKitWebView* _tmp1_;
	WebKitWebView* _tmp2_;
#line 96 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	parent_class = G_OBJECT_CLASS (midori_tab_parent_class);
#line 96 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 96 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MIDORI_TYPE_TAB, MidoriTab);
#line 105 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = (WebKitWebView*) webkit_web_view_new ();
#line 105 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_ref_sink (_tmp0_);
#line 105 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = _tmp0_;
#line 105 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	midori_tab_set_web_view (self, _tmp1_);
#line 105 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_g_object_unref0 (_tmp1_);
#line 107 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp2_ = self->priv->_web_view;
#line 107 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	webkit_web_view_load_uri (_tmp2_, "");
#line 96 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	return obj;
#line 1342 "midori-tab.c"
}


static void midori_tab_class_init (MidoriTabClass * klass) {
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	midori_tab_parent_class = g_type_class_peek_parent (klass);
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_type_class_add_private (klass, sizeof (MidoriTabPrivate));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_midori_tab_get_property;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_midori_tab_set_property;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	G_OBJECT_CLASS (klass)->constructor = midori_tab_constructor;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	G_OBJECT_CLASS (klass)->finalize = midori_tab_finalize;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_TAB_WEB_VIEW, g_param_spec_object ("web-view", "web-view", "web-view", WEBKIT_TYPE_WEB_VIEW, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_TAB_URI, g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_TAB_SPECIAL, g_param_spec_boolean ("special", "special", "special", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_TAB_MIME_TYPE, g_param_spec_string ("mime-type", "mime-type", "mime-type", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_TAB_SECURITY, g_param_spec_enum ("security", "security", "security", MIDORI_TYPE_SECURITY, MIDORI_SECURITY_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_TAB_LOAD_STATUS, g_param_spec_enum ("load-status", "load-status", "load-status", MIDORI_TYPE_LOAD_STATUS, MIDORI_LOAD_FINISHED, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_TAB_STATUSBAR_TEXT, g_param_spec_string ("statusbar-text", "statusbar-text", "statusbar-text", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_TAB_PROGRESS, g_param_spec_double ("progress", "progress", "progress", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_TAB_VIEW_SOURCE, g_param_spec_boolean ("view-source", "view-source", "view-source", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_signal_new ("console_message", MIDORI_TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_INT_STRING, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_INT, G_TYPE_STRING);
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_signal_new ("attach_inspector", MIDORI_TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, WEBKIT_TYPE_WEB_VIEW);
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_signal_new ("detach_inspector", MIDORI_TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, WEBKIT_TYPE_WEB_VIEW);
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	g_signal_new ("search_text", MIDORI_TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOOLEAN_STRING, G_TYPE_NONE, 2, G_TYPE_BOOLEAN, G_TYPE_STRING);
#line 1385 "midori-tab.c"
}


static void midori_tab_instance_init (MidoriTab * self) {
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv = MIDORI_TAB_GET_PRIVATE (self);
#line 43 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp0_ = g_strdup ("about:blank");
#line 43 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->current_uri = _tmp0_;
#line 53 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->_special = FALSE;
#line 55 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_tmp1_ = g_strdup ("text/plain");
#line 55 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->_mime_type = _tmp1_;
#line 57 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->_security = MIDORI_SECURITY_NONE;
#line 58 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->_load_status = MIDORI_LOAD_FINISHED;
#line 59 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->_statusbar_text = NULL;
#line 61 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->_fg_color = NULL;
#line 62 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->_bg_color = NULL;
#line 65 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self->priv->current_progress = 0.0;
#line 1416 "midori-tab.c"
}


static void midori_tab_finalize (GObject* obj) {
	MidoriTab * self;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MIDORI_TYPE_TAB, MidoriTab);
#line 37 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_g_object_unref0 (self->priv->_web_view);
#line 43 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_g_free0 (self->priv->current_uri);
#line 55 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_g_free0 (self->priv->_mime_type);
#line 59 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_g_free0 (self->priv->_statusbar_text);
#line 61 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_g_free0 (self->priv->_fg_color);
#line 62 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	_g_free0 (self->priv->_bg_color);
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	G_OBJECT_CLASS (midori_tab_parent_class)->finalize (obj);
#line 1438 "midori-tab.c"
}


GType midori_tab_get_type (void) {
	static volatile gsize midori_tab_type_id__volatile = 0;
	if (g_once_init_enter (&midori_tab_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MidoriTabClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) midori_tab_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MidoriTab), 0, (GInstanceInitFunc) midori_tab_instance_init, NULL };
		GType midori_tab_type_id;
		midori_tab_type_id = g_type_register_static (GTK_TYPE_VBOX, "MidoriTab", &g_define_type_info, 0);
		g_once_init_leave (&midori_tab_type_id__volatile, midori_tab_type_id);
	}
	return midori_tab_type_id__volatile;
}


static void _vala_midori_tab_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MidoriTab * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MIDORI_TYPE_TAB, MidoriTab);
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	switch (property_id) {
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_WEB_VIEW:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		g_value_set_object (value, midori_tab_get_web_view (self));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_URI:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		g_value_set_string (value, midori_tab_get_uri (self));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_SPECIAL:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		g_value_set_boolean (value, midori_tab_get_special (self));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_MIME_TYPE:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		g_value_set_string (value, midori_tab_get_mime_type (self));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_SECURITY:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		g_value_set_enum (value, midori_tab_get_security (self));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_LOAD_STATUS:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		g_value_set_enum (value, midori_tab_get_load_status (self));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_STATUSBAR_TEXT:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		g_value_set_string (value, midori_tab_get_statusbar_text (self));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_PROGRESS:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		g_value_set_double (value, midori_tab_get_progress (self));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_VIEW_SOURCE:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		g_value_set_boolean (value, midori_tab_get_view_source (self));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 1513 "midori-tab.c"
		default:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 1519 "midori-tab.c"
	}
}


static void _vala_midori_tab_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	MidoriTab * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MIDORI_TYPE_TAB, MidoriTab);
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
	switch (property_id) {
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_WEB_VIEW:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		midori_tab_set_web_view (self, g_value_get_object (value));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_URI:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		midori_tab_set_uri (self, g_value_get_string (value));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_SPECIAL:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		midori_tab_set_special (self, g_value_get_boolean (value));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_MIME_TYPE:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		midori_tab_set_mime_type (self, g_value_get_string (value));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_SECURITY:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		midori_tab_set_security (self, g_value_get_enum (value));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_LOAD_STATUS:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		midori_tab_set_load_status (self, g_value_get_enum (value));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_STATUSBAR_TEXT:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		midori_tab_set_statusbar_text (self, g_value_get_string (value));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_PROGRESS:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		midori_tab_set_progress (self, g_value_get_double (value));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		case MIDORI_TAB_VIEW_SOURCE:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		midori_tab_set_view_source (self, g_value_get_boolean (value));
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 1583 "midori-tab.c"
		default:
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "/tmp/B.67ae55c9-1eba-4713-8dd0-11f2ca2cc415/BUILD/midori-0.5.2/midori/midori-tab.vala"
		break;
#line 1589 "midori-tab.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



